import { html, ref, repeat, when } from '@microsoft/fast-element';
export const listTemplate = html `
  <div class="container">
    ${when((x) => x.enableFilterBar, html `
        <zero-filter-bar
          resource=${(x) => x.resourceName}
          only=${(x) => x.columns?.map((colDef) => colDef.field).filter((field) => !!field)}
          labels=${(x) => x.columns?.map((colDef) => colDef.headerName || '')}
          target="datasource"
        ></zero-filter-bar>
      `)}
    <zero-grid-pro
      ${ref('grid')}
      auto-cell-renderer-by-type
      rowSelection="single"
      rowHeight="36"
      headerHeight="36"
      persist-column-state-key=${(x) => x.persistColumnStateKey}
      ?only-template-col-defs=${(x) => !!x.columns}
      suppressCellFocus="true"
      suppressRowDeselection="true"
      enable-cell-flashing=${(x) => x.enableCellFlashing}
    >
      <grid-pro-genesis-datasource
        ${ref('datasource')}
        :deferredGridOptions=${(x) => x.gridOptions}
        resource-name=${(x) => x.resourceName}
        criteria=${(x) => x.datasourceConfig?.criteria}
        fields=${(x) => x.datasourceConfig?.fields}
        is-snapshot=${(x) => x.datasourceConfig?.isSnapshot}
        max-rows=${(x) => x.datasourceConfig?.maxRows}
        max-view=${(x) => x.datasourceConfig?.maxView}
        order-by=${(x) => x.datasourceConfig?.orderBy}
        reverse=${(x) => x.datasourceConfig?.reverse}
      ></grid-pro-genesis-datasource>
      ${repeat((x) => x.columns, html `
          <grid-pro-column :definition=${(x) => x}></grid-pro-column>
        `)}
      ${repeat((x) => x.actionButtonsConfig, html `
          <grid-pro-column :definition=${(x) => x}></grid-pro-column>
        `)}
    </zero-grid-pro>
  </div>
`;
